14 Commits
0.1 ... 0.3

Author SHA1 Message Date
emmett1
0440395881 fix 2020-02-10 17:44:48 +08:00
emmett1
6dddc034f9 updated 2020-02-10 00:18:14 +08:00
emmett1
4d8f539f45 updated 2020-02-08 23:44:01 +08:00
emmett1
cfaca4e65f updated 2020-02-08 17:50:37 +08:00
emmett1
0a9cfce26a add xchroot script 2020-02-07 23:31:35 +08:00
emmett1
5eeb974b17 updated 2020-02-07 23:22:30 +08:00
emmett1
2e26f7c2f0 add package alias function 2020-02-06 13:35:11 +08:00
emmett1
6e4134550e fix typo 2020-02-01 11:40:11 +08:00
emmett1
be8cbb552a add sort to pkgquery and scratch search function 2020-01-31 23:19:21 +08:00
emmett1
cf8d6c9cc9 fix generate_pkgfiles on pkgbuild 2020-01-20 11:53:54 +08:00
emmett1
b5733b2f8f fix scratch_build 2020-01-17 22:59:54 +08:00
emmett1
b6710e58c4 fix scratch search and pkgquery search 2020-01-16 10:05:32 +08:00
emmett1
0b78bb986d fix typos 2020-01-16 00:17:24 +08:00
emmett1
3b7a73c0d8 bring back search function to scratch, maybe for now 2020-01-15 12:45:38 +08:00
10 changed files with 325 additions and 136 deletions

View File

@@ -14,10 +14,9 @@ install -d ${DESTDIR}${REVDEPD}
install -dm777 ${DESTDIR}${CACHE_DIR}/packages install -dm777 ${DESTDIR}${CACHE_DIR}/packages
install -dm777 ${DESTDIR}${CACHE_DIR}/sources install -dm777 ${DESTDIR}${CACHE_DIR}/sources
install -dm777 ${DESTDIR}${CACHE_DIR}/log
install -dm777 ${DESTDIR}${CACHE_DIR}/work install -dm777 ${DESTDIR}${CACHE_DIR}/work
install -m755 revdep pkgadd pkgdel pkgbuild pkgquery scratch updateconf ${DESTDIR}${BINDIR} install -m755 xchroot revdep pkgadd pkgdel pkgbuild pkgquery scratch updateconf ${DESTDIR}${BINDIR}
install -m644 scratchpkg.conf scratchpkg.repo ${DESTDIR}${CONFDIR} install -m644 scratchpkg.conf scratchpkg.repo scratchpkg.alias ${DESTDIR}${CONFDIR}
install -m644 revdep.conf ${DESTDIR}${REVDEPCONF} install -m644 revdep.conf ${DESTDIR}${REVDEPCONF}

124
pkgadd
View File

@@ -70,9 +70,9 @@ extract_opts() {
--*) opts="$opts $1";; --*) opts="$opts $1";;
-*) char=${#1}; count=1 -*) char=${#1}; count=1
while [ "$count" != "$char" ]; do while [ "$count" != "$char" ]; do
count=$((count+1)) count=$((count+1))
opts="$opts -$(echo $1 | cut -c $count)" opts="$opts -$(echo $1 | cut -c $count)"
done;; done;;
*) opts="$opts $1" *) opts="$opts $1"
esac esac
shift shift
@@ -93,12 +93,12 @@ parse_opts() {
-h | --help) SHOWHELP=yes ;; -h | --help) SHOWHELP=yes ;;
--no-preinstall) NO_PREINSTALL=yes ;; --no-preinstall) NO_PREINSTALL=yes ;;
--no-postinstall) NO_POSTINSTALL=yes ;; --no-postinstall) NO_POSTINSTALL=yes ;;
--no-preupgrade) NO_PREUPGRADE=yes ;; --no-preupgrade) NO_PREUPGRADE=yes ;;
--no-postupgrade) NO_POSTUPGRADE=yes ;; --no-postupgrade) NO_POSTUPGRADE=yes ;;
--no-backup) NO_BACKUP=yes ;; --no-backup) NO_BACKUP=yes ;;
--root=*) ROOT_DIR="${1#*=}" ;; --root=*) ROOT_DIR="${1#*=}" ;;
*.spkg.tar.*) PKGNAME="$(realpath $1)" ;; *.spkg.tar.*) PKGNAME="$(realpath $1)" ;;
*) msg "Invalid option! ($1)"; exit 1 ;; *) msg "Invalid option! ($1)"; exit 1 ;;
esac esac
shift shift
done done
@@ -107,30 +107,31 @@ parse_opts() {
ret() { ret() {
# remove lock and all tmp files on exit # remove lock and all tmp files on exit
rm -f "$LOCK_FILE" "$TMP_PKGADD" "$TMP_PKGINSTALL" "$TMP_CONFLICT" rm -f "$ROOT_DIR/$LOCK_FILE" "$TMP_PKGADD" "$TMP_PKGINSTALL" "$TMP_CONFLICT"
exit $1 exit $1
} }
isinstalled() { isinstalled() {
if [ -s "$INDEX_DIR/$1/.pkginfo" ] && grep -q "$1" "$INDEX_DIR/$1/.pkginfo"; then if [ -s "$ROOT_DIR/$INDEX_DIR/$1/.pkginfo" ] && grep -q "$1" "$ROOT_DIR/$INDEX_DIR/$1/.pkginfo"; then
return 0 return 0
else else
return 1 return 1
fi fi
} }
run_scripts() {
if [ "$ROOT_DIR" ]; then
xchroot "$ROOT_DIR" sh $@
else
sh $@
fi
}
parse_opts $(extract_opts "$@") parse_opts $(extract_opts "$@")
INDEX_DIR="$ROOT_DIR/var/lib/scratchpkg/index" SCRATCHPKG_DIR="var/lib/scratchpkg"
LOCK_FILE="$ROOT_DIR/var/lib/scratchpkg/spkg.lock" INDEX_DIR="$SCRATCHPKG_DIR/index"
LOCK_FILE="$SCRATCHPKG_DIR/spkg.lock"
# disable pre/post install/upgrade script when install to custom root location
if [ "$ROOT_DIR" != "" ]; then
NO_PREINSTALL=yes
NO_POSTINSTALL=yes
NO_PREUPGRADE=yes
NO_POSTUPGRADE=yes
fi
# show help page # show help page
[ "$SHOWHELP" ] || [ -z "$PKGNAME" ] && { [ "$SHOWHELP" ] || [ -z "$PKGNAME" ] && {
@@ -138,25 +139,25 @@ fi
ret 0 ret 0
} }
[ -d "$INDEX_DIR" ] || { [ -d "$ROOT_DIR/$INDEX_DIR" ] || {
msgerr "Package's database directory not exist! ($INDEX_DIR)" msgerr "Package's database directory not exist! ($ROOT_DIR$/INDEX_DIR)"
ret 1 ret 1
} }
# check for root access, non-root only allowed if use custom --root= location # check for root access
[ "$(id -u)" = "0" ] || [ "$ROOT_DIR" ] || { [ "$(id -u)" = "0" ] || {
msgerr "Installing package need root access!" msgerr "Installing package need root access!"
ret 1 ret 1
} }
# check for lock file # check for lock file
[ -f "$LOCK_FILE" ] && { [ -f "$ROOT_DIR/$LOCK_FILE" ] && {
msgerr "Cant install/remove package simultaneously." msgerr "Cant install/remove package simultaneously."
msgerr "remove '$LOCK_FILE' if no install/remove package process running." msgerr "remove '$ROOT_DIR/$LOCK_FILE' if no install/remove package process running."
} }
touch "$LOCK_FILE" 2>/dev/null || { touch "$ROOT_DIR/$LOCK_FILE" 2>/dev/null || {
msgerr "Cant create lock file in '$LOCK_FILE'." msgerr "Cant create lock file in '$ROOT_DIR/$LOCK_FILE'."
exit 1 exit 1
} }
@@ -176,8 +177,8 @@ name=${noextname%-*}
# get package information if installed # get package information if installed
if isinstalled $name; then if isinstalled $name; then
iversion=$(grep ^version $INDEX_DIR/$name/.pkginfo | cut -d " " -f3-) iversion=$(grep ^version $ROOT_DIR/$INDEX_DIR/$name/.pkginfo | cut -d " " -f3-)
irelease=$(grep ^release $INDEX_DIR/$name/.pkginfo | cut -d " " -f3-) irelease=$(grep ^release $ROOT_DIR/$INDEX_DIR/$name/.pkginfo | cut -d " " -f3-)
ALREADYINSTALLED=yes ALREADYINSTALLED=yes
fi fi
@@ -200,9 +201,9 @@ if [ "$UPGRADE_PKG" ] || [ "$REINSTALL_PKG" ]; then
fi fi
fi fi
TMP_PKGADD="/tmp/.tmp_pkgadd.$$" TMP_PKGADD="$ROOT_DIR/$SCRATCHPKG_DIR/.tmp_pkgadd"
TMP_PKGINSTALL="/tmp/.tmp_pkginstall.$$" TMP_PKGINSTALL="$ROOT_DIR/$SCRATCHPKG_DIR/.tmp_pkginstall"
TMP_CONFLICT="/tmp/.tmp_conflict.$$" TMP_CONFLICT="$ROOT_DIR/$SCRATCHPKG_DIR/.tmp_conflict"
# check integrity of package and save list file/dirs to install in the meantime # check integrity of package and save list file/dirs to install in the meantime
tar -tf $PKGNAME > $TMP_PKGADD 2>/dev/null || { tar -tf $PKGNAME > $TMP_PKGADD 2>/dev/null || {
@@ -225,7 +226,7 @@ if [ ! "$IGNORE_CONFLICT" ]; then
fi fi
if [ -e "$ROOT_DIR/$line" ] || [ -L "$ROOT_DIR/$line" ]; then if [ -e "$ROOT_DIR/$line" ] || [ -L "$ROOT_DIR/$line" ]; then
if [ "$UPGRADE_PKG" ] || [ "$REINSTALL_PKG" ]; then if [ "$UPGRADE_PKG" ] || [ "$REINSTALL_PKG" ]; then
if ! grep -Fqx "$line" "$INDEX_DIR/$name/.files"; then if ! grep -Fqx "$line" "$ROOT_DIR/$INDEX_DIR/$name/.files"; then
echo "$line" echo "$line"
touch "$TMP_CONFLICT" touch "$TMP_CONFLICT"
fi fi
@@ -244,19 +245,19 @@ fi
# pre-install and pre-upgrade script # pre-install and pre-upgrade script
if grep -qx .pkginstall $TMP_PKGADD; then if grep -qx .pkginstall $TMP_PKGADD; then
TMP_PKGINSTALL_SCRIPT="/tmp/.tmp_pkgadd_installscript.$$" TMP_PKGINSTALL_SCRIPT="$SCRATCHPKG_DIR/pkgadd_installscript"
tar -xf "$PKGNAME" .pkginstall -O > "$TMP_PKGINSTALL_SCRIPT" tar -xf "$PKGNAME" .pkginstall -O > "$ROOT_DIR/$TMP_PKGINSTALL_SCRIPT"
if [ ! "$NO_PREINSTALL" ] && [ ! "$UPGRADE_PKG" ]; then if [ ! "$NO_PREINSTALL" ] && [ ! "$UPGRADE_PKG" ]; then
(cd "$ROOT_DIR"/ (cd "$ROOT_DIR"/
sh "$TMP_PKGINSTALL_SCRIPT" pre-install "$version" run_scripts "$TMP_PKGINSTALL_SCRIPT" pre-install "$version"
) )
fi fi
if [ "$UPGRADE_PKG" ] && [ ! "$NO_PREUPGRADE" ]; then if [ "$UPGRADE_PKG" ] && [ ! "$NO_PREUPGRADE" ]; then
(cd "$ROOT_DIR"/ (cd "$ROOT_DIR"/
sh "$TMP_PKGINSTALL_SCRIPT" pre-upgrade "$version" "$iversion" run_scripts "$TMP_PKGINSTALL_SCRIPT" pre-upgrade "$version" "$iversion"
) )
fi fi
rm -f "$TMP_PKGINSTALL_SCRIPT" rm -f "$ROOT_DIR/$TMP_PKGINSTALL_SCRIPT"
fi fi
# exclude .pkg* files when extract into system # exclude .pkg* files when extract into system
@@ -284,17 +285,18 @@ done
# remove old files from old package that not exist in new package # remove old files from old package that not exist in new package
if [ "$UPGRADE_PKG" ] || [ "$REINSTALL_PKG" ]; then if [ "$UPGRADE_PKG" ] || [ "$REINSTALL_PKG" ]; then
rmlist_file="/tmp/.rmlist_file.$$" rmlist_file="$ROOT_DIR/$SCRATCHPKG_DIR/.rmlist_file"
rmlist_dir="/tmp/.rmlist_dir.$$" rmlist_dir="$ROOT_DIR/$SCRATCHPKG_DIR/.rmlist_dir"
reserve_dir="/tmp/.reserve_dir.$$" reserve_dir="$ROOT_DIR/$SCRATCHPKG_DIR/.reserve_dir"
rmlist_all="/tmp/.rmlist_all.$$" rmlist_all="$ROOT_DIR/$SCRATCHPKG_DIR/.rmlist_all"
grep '/$' $INDEX_DIR/*/.files | grep -v $INDEX_DIR/$name/.files | awk -F : '{print $2}' | sort | uniq > $reserve_dir # get list reserved dirs grep '/$' $ROOT_DIR/$INDEX_DIR/*/.files \
grep -Fxv -f "$TMP_PKGINSTALL" $INDEX_DIR/$name/.files > $rmlist_all # get list files and dirs to remove | grep -v $ROOT_DIR/$INDEX_DIR/$name/.files \
grep -v '/$' "$rmlist_all" | tac > "$rmlist_file" # get files only to remove | awk -F : '{print $2}' \
grep -Fxv -f "$reserve_dir" "$rmlist_all" | grep '/$' | tac > "$rmlist_dir" # get dirs only (safe) to remove | sort \
# remove pseudo fs from remove list | uniq > $reserve_dir # get list reserved dirs
#sed '/^dev\//d;/^sys\//d;/^proc\//d;/^run\//d;/^tmp\//d' -i $rmlist_file grep -Fxv -f "$TMP_PKGINSTALL" $ROOT_DIR/$INDEX_DIR/$name/.files > $rmlist_all # get list files and dirs to remove
#sed '/^dev\//d;/^sys\//d;/^proc\//d;/^run\//d;/^tmp\//d' -i $rmlist_dir grep -v '/$' "$rmlist_all" | tac > "$rmlist_file" # get files only to remove
grep -Fxv -f "$reserve_dir" "$rmlist_all" | grep '/$' | tac > "$rmlist_dir" # get dirs only (safe) to remove
(cd "$ROOT_DIR"/ (cd "$ROOT_DIR"/
[ -s $rmlist_file ] && xargs -a $rmlist_file -d'\n' rm $VERBOSE_INSTALL [ -s $rmlist_file ] && xargs -a $rmlist_file -d'\n' rm $VERBOSE_INSTALL
[ -s $rmlist_dir ] && xargs -a $rmlist_dir -d'\n' rmdir $VERBOSE_INSTALL [ -s $rmlist_dir ] && xargs -a $rmlist_dir -d'\n' rmdir $VERBOSE_INSTALL
@@ -303,30 +305,30 @@ if [ "$UPGRADE_PKG" ] || [ "$REINSTALL_PKG" ]; then
fi fi
# register package into database # register package into database
rm -fr "$INDEX_DIR/$name" rm -fr "$ROOT_DIR/$INDEX_DIR/$name"
mkdir "$INDEX_DIR/$name" mkdir "$ROOT_DIR/$INDEX_DIR/$name"
echo "name = $name" > "$INDEX_DIR/$name/.pkginfo" echo "name = $name" > "$ROOT_DIR/$INDEX_DIR/$name/.pkginfo"
echo "version = $version" >> "$INDEX_DIR/$name/.pkginfo" echo "version = $version" >> "$ROOT_DIR/$INDEX_DIR/$name/.pkginfo"
echo "release = $release" >> "$INDEX_DIR/$name/.pkginfo" echo "release = $release" >> "$ROOT_DIR/$INDEX_DIR/$name/.pkginfo"
install -m644 "$TMP_PKGINSTALL" "$INDEX_DIR/$name/.files" install -m644 "$TMP_PKGINSTALL" "$ROOT_DIR/$INDEX_DIR/$name/.files"
for ii in $(grep ^.pkg* $TMP_PKGADD); do for ii in $(grep ^.pkg* $TMP_PKGADD); do
pkgfiles="$pkgfiles $ii" pkgfiles="$pkgfiles $ii"
done done
if [ "$pkgfiles" ]; then if [ "$pkgfiles" ]; then
tar -x -f "$PKGNAME" -C "$INDEX_DIR/$name" $pkgfiles >/dev/null 2>&1 tar -x -f "$PKGNAME" -C "$ROOT_DIR/$INDEX_DIR/$name" $pkgfiles >/dev/null 2>&1
fi fi
if [ -f "$INDEX_DIR/$name/.pkginstall" ]; then if [ -f "$ROOT_DIR/$INDEX_DIR/$name/.pkginstall" ]; then
if [ ! "$NO_POSTINSTALL" ] && [ ! "$UPGRADE_PKG" ]; then if [ ! "$NO_POSTINSTALL" ] && [ ! "$UPGRADE_PKG" ]; then
(cd "$ROOT_DIR"/ (cd "$ROOT_DIR"/
sh "$INDEX_DIR/$name/.pkginstall" post-install "$version" run_scripts "$INDEX_DIR/$name/.pkginstall" post-install "$version"
) )
fi fi
if [ "$UPGRADE_PKG" ] && [ ! "$NO_POSTUPGRADE" ]; then if [ "$UPGRADE_PKG" ] && [ ! "$NO_POSTUPGRADE" ]; then
(cd "$ROOT_DIR"/ (cd "$ROOT_DIR"/
sh "$INDEX_DIR/$name/.pkginstall" post-upgrade "$version" "$iversion" run_scripts "$INDEX_DIR/$name/.pkginstall" post-upgrade "$version" "$iversion"
) )
fi fi
fi fi

View File

@@ -291,6 +291,24 @@ backupconf() {
done done
} }
removedocs() {
for i in doc gtk-doc info; do
rm -fr \
usr/share/$i \
usr/$i \
usr/local/$i \
usr/local/share/$i
done
}
removelocales() {
rm -fr \
usr/share/locale \
usr/locale \
usr/local/locale \
usr/local/share/locale
}
packaging() { packaging() {
for FILE in $INCLUDEINPKG; do for FILE in $INCLUDEINPKG; do
if [ -f $FILE ]; then if [ -f $FILE ]; then
@@ -316,6 +334,8 @@ packaging() {
[ "$KEEP_LIBTOOL" = 0 ] && removelibtool [ "$KEEP_LIBTOOL" = 0 ] && removelibtool
[ "$STRIP_BINARY" = 1 ] && strip_files [ "$STRIP_BINARY" = 1 ] && strip_files
[ "$ZIP_MAN" = 1 ] && compressinfomanpages [ "$ZIP_MAN" = 1 ] && compressinfomanpages
[ "$KEEP_DOCS" = 0 ] && removedocs
[ "$KEEP_LOCALES" = 0 ] && removelocales
if [ "${#backup[@]}" -gt 0 ]; then if [ "${#backup[@]}" -gt 0 ]; then
backupconf backupconf
@@ -356,7 +376,7 @@ generate_pkgfiles() {
msg "Generating .pkgfiles..." msg "Generating .pkgfiles..."
tar -tvf "$PACKAGE_DIR/$PKGNAME" $excludefile \ tar -tvf "$PACKAGE_DIR/$PKGNAME" $excludefile \
| awk '{print $1,$2,$6}' \ | awk '{$3=$4=$5=""; print $0}' \
| sed "s,lib/modules/$(uname -r),lib/modules/<kernelversion>,g" \ | sed "s,lib/modules/$(uname -r),lib/modules/<kernelversion>,g" \
| sort -k 3 > .pkgfiles | sort -k 3 > .pkgfiles
} }
@@ -427,6 +447,10 @@ set_options() {
!makeflags) MAKE_FLAGS=0 ;; !makeflags) MAKE_FLAGS=0 ;;
checksum) CHECK_MDSUM=1 ;; checksum) CHECK_MDSUM=1 ;;
!checksum) CHECK_MDSUM=0 ;; !checksum) CHECK_MDSUM=0 ;;
docs) KEEP_DOCS=1 ;;
!docs) KEEP_DOCS=0 ;;
locales) KEEP_LOCALES=1 ;;
!locales) KEEP_LOCALES=0 ;;
esac esac
done done
} }
@@ -641,6 +665,7 @@ main() {
abort 0 abort 0
fi fi
else else
msg "Building '$name-$version-$release'..."
download_src download_src
prepare_src prepare_src
run_build run_build
@@ -669,7 +694,7 @@ WORK_DIR="/var/cache/scratchpkg/work"
DOWNLOAD_PROG="wget" DOWNLOAD_PROG="wget"
COMPRESSION_MODE="xz" COMPRESSION_MODE="xz"
OPTIONS="!libtool emptydirs strip zipman buildflags makeflags checksum" OPTIONS="!libtool emptydirs strip zipman buildflags makeflags checksum !docs !locales"
INCLUDEINPKG="install readme mkdirs" INCLUDEINPKG="install readme mkdirs"

78
pkgdel
View File

@@ -83,10 +83,10 @@ parse_opts() {
-h | --help) SHOWHELP=yes ;; -h | --help) SHOWHELP=yes ;;
-v | --verbose) VERBOSE_REMOVE="-v" ;; -v | --verbose) VERBOSE_REMOVE="-v" ;;
--no-preremove) NO_PREREMOVE=yes ;; --no-preremove) NO_PREREMOVE=yes ;;
--no-postremove) NO_POSTREMOVE=yes ;; --no-postremove) NO_POSTREMOVE=yes ;;
--root=*) ROOT_DIR="${1#*=}" ;; --root=*) ROOT_DIR="${1#*=}" ;;
-*) msg "Invalid option: ($1)"; exit 1 ;; -*) msg "Invalid option: ($1)"; exit 1 ;;
*) RMNAME=$1 ;; *) RMNAME=$1 ;;
esac esac
shift shift
done done
@@ -95,28 +95,30 @@ parse_opts() {
ret() { ret() {
# remove lock file on exit # remove lock file on exit
rm -f "$LOCK_FILE" "$reserve" "$dirs" "$remove" "$files" rm -f "$ROOT_DIR/$LOCK_FILE" "$reserve" "$dirs" "$remove" "$files"
exit $1 exit $1
} }
isinstalled() { isinstalled() {
if [ -s "$INDEX_DIR/$1/.pkginfo" ] && grep -q "$1" "$INDEX_DIR/$1/.pkginfo"; then if [ -s "$ROOT_DIR/$INDEX_DIR/$1/.pkginfo" ] && grep -q "$1" "$ROOT_DIR/$INDEX_DIR/$1/.pkginfo"; then
return 0 return 0
else else
return 1 return 1
fi fi
} }
run_scripts() {
if [ "$ROOT_DIR" ]; then
xchroot "$ROOT_DIR" sh $@
else
sh $@
fi
}
parse_opts $(extract_opts "$@") parse_opts $(extract_opts "$@")
INDEX_DIR="$ROOT_DIR/var/lib/scratchpkg/index" INDEX_DIR="var/lib/scratchpkg/index"
LOCK_FILE="$ROOT_DIR/var/lib/scratchpkg/spkg.lock" LOCK_FILE="var/lib/scratchpkg/spkg.lock"
# disable pre/post remove script when remove from custom root location
if [ "$ROOT_DIR" != "" ]; then
NO_PREREMOVE=yes
NO_POSTREMOVE=yes
fi
# show help page # show help page
[ "$SHOWHELP" ] || [ -z "$RMNAME" ] && { [ "$SHOWHELP" ] || [ -z "$RMNAME" ] && {
@@ -124,21 +126,21 @@ fi
ret 0 ret 0
} }
# check for root access, non-root only allowed if use custom --root= location # check for root access
[ "$(id -u)" = "0" ] || [ "$ROOT_DIR" ] || { [ "$(id -u)" = "0" ] || {
echo "Removing package need root access!" echo "Removing package need root access!"
ret 1 ret 1
} }
# check for lock file # check for lock file
[ -f "$LOCK_FILE" ] && { [ -f "$ROOT_DIR/$LOCK_FILE" ] && {
msgerr "Cant install/remove package simultaneously." msgerr "Cant install/remove package simultaneously."
msgerr "remove '$LOCK_FILE' if no install/remove package process running." msgerr "remove '$ROOT_DIR/$LOCK_FILE' if no install/remove package process running."
exit 1 exit 1
} }
touch "$LOCK_FILE" 2>/dev/null || { touch "$ROOT_DIR/$LOCK_FILE" 2>/dev/null || {
msgerr "Cant create lock file in '$LOCK_FILE'" msgerr "Cant create lock file in '$ROOT_DIR/$LOCK_FILE'"
exit 1 exit 1
} }
@@ -147,32 +149,36 @@ if ! isinstalled "$RMNAME"; then
ret 1 ret 1
fi fi
name=$(grep ^name $INDEX_DIR/$RMNAME/.pkginfo | cut -d " " -f3-) name=$(grep ^name $ROOT_DIR/$INDEX_DIR/$RMNAME/.pkginfo | cut -d " " -f3-)
version=$(grep ^version $INDEX_DIR/$RMNAME/.pkginfo | cut -d " " -f3-) version=$(grep ^version $ROOT_DIR/$INDEX_DIR/$RMNAME/.pkginfo | cut -d " " -f3-)
release=$(grep ^release $INDEX_DIR/$RMNAME/.pkginfo | cut -d " " -f3-) release=$(grep ^release $ROOT_DIR/$INDEX_DIR/$RMNAME/.pkginfo | cut -d " " -f3-)
if [ -z $name ] && [ -z $version ] && [ -z $release ]; then if [ -z "$name" ] && [ -z "$version" ] && [ -z "$release" ]; then
msgerr "Package '$RMNAME' not installed but exist in database." msgerr "Package '$RMNAME' not installed but exist in database."
ret 1 ret 1
fi fi
# create list for reserve and remove (dirs and files) # create list for reserve and remove (dirs and files)
reserve="/tmp/.pkgdel_reserve.$$" reserve="$ROOT_DIR/$SCRATCHPKG_DIR/.pkgdel_reserve"
remove="/tmp/.pkgdel_remove.$$" remove="$ROOT_DIR/$SCRATCHPKG_DIR/.pkgdel_remove"
dirs="/tmp/.pkgdel_dirs.$$" dirs="$ROOT_DIR/$SCRATCHPKG_DIR/.pkgdel_dirs"
files="/tmp/.pkgdel_files.$$" files="$ROOT_DIR/$SCRATCHPKG_DIR/.pkgdel_files"
grep '/$' $INDEX_DIR/*/.files | grep -v "$INDEX_DIR/$name" | awk -F : '{print $2}' | sort | uniq > "$reserve" grep '/$' $ROOT_DIR/$INDEX_DIR/*/.files \
grep '/$' "$INDEX_DIR/$name/.files" > "$remove" | grep -v "$ROOT_DIR/$INDEX_DIR/$name" \
| awk -F : '{print $2}' \
| sort \
| uniq > "$reserve"
grep '/$' "$ROOT_DIR/$INDEX_DIR/$name/.files" > "$remove"
grep -Fxv -f "$reserve" "$remove" | tac > "$dirs" grep -Fxv -f "$reserve" "$remove" | tac > "$dirs"
grep -v '/$' "$INDEX_DIR/$name/.files" | tac >> "$files" grep -v '/$' "$ROOT_DIR/$INDEX_DIR/$name/.files" | tac >> "$files"
echo "remove: $name-$version-$release..." echo "remove: $name-$version-$release..."
# pre-remove script # pre-remove script
if [ ! "$NO_PREREMOVE" ] && [ -f "$INDEX_DIR/$name/.pkginstall" ]; then if [ ! "$NO_PREREMOVE" ] && [ -f "$ROOT_DIR/$INDEX_DIR/$name/.pkginstall" ]; then
(cd "$ROOT_DIR"/ (cd "$ROOT_DIR"/
sh "$INDEX_DIR/$name/.pkginstall" pre-remove "$version" run_scripts "$INDEX_DIR/$name/.pkginstall" pre-remove "$version"
) )
fi fi
@@ -185,14 +191,14 @@ fi
rm -f "$reserve" "$dirs" "$remove" "$files" rm -f "$reserve" "$dirs" "$remove" "$files"
# post-remove script # post-remove script
if [ ! "$NO_POSTREMOVE" ] && [ -f "$INDEX_DIR/$name/.pkginstall" ]; then if [ ! "$NO_POSTREMOVE" ] && [ -f "$ROOT_DIR/$INDEX_DIR/$name/.pkginstall" ]; then
(cd "$ROOT_DIR"/ (cd "$ROOT_DIR"/
sh "$INDEX_DIR/$name/.pkginstall" post-remove "$version" run_scripts "$INDEX_DIR/$name/.pkginstall" post-remove "$version"
) )
fi fi
# remove from database # remove from database
rm -rf "$INDEX_DIR/$name" rm -rf "$ROOT_DIR/$INDEX_DIR/$name"
# running ldconfig # running ldconfig
if [ -x "$ROOT_DIR"/sbin/ldconfig ]; then if [ -x "$ROOT_DIR"/sbin/ldconfig ]; then

View File

@@ -67,13 +67,27 @@ installed_pkg_info() {
fi fi
} }
deps_alias() {
[ -f $ALIAS_FILE ] || {
echo $@
return
}
while [ "$1" ]; do
getalias=$(grep -w ^$1 $ALIAS_FILE | awk '{print $2}')
echo ${getalias:-$1}
shift
done
unset getalias
}
getdepends() { getdepends() {
ppath=$(getportpath $1) || return 0 ppath=$(getportpath $1) || return 0
grep "^# depends[[:blank:]]*:" $ppath/$BUILD_SCRIPT \ deps=$(grep "^# depends[[:blank:]]*:" $ppath/$BUILD_SCRIPT \
| sed 's/^# depends[[:blank:]]*:[[:blank:]]*//' \ | sed 's/^# depends[[:blank:]]*:[[:blank:]]*//' \
| tr ' ' '\n' \ | tr ' ' '\n' \
| awk '!a[$0]++' \ | awk '!a[$0]++' \
| sed 's/,//' | sed 's/,//')
deps_alias $deps
} }
getportpath() { getportpath() {
@@ -145,16 +159,14 @@ pkg_search() {
needarg $@ needarg $@
arg=$* arg=$*
for repo in $REPO; do for repo in $REPO; do
out=$(grep -R "# description" $repo | grep $BUILD_SCRIPT | grep "$arg" | awk -F : '{print $1}') out=$(grep -R "# description" $repo | grep $BUILD_SCRIPT | grep "$arg" | awk -F : '{print $1}' | sort)
[ "$out" ] || continue [ "$out" ] || continue
for line in $out; do for line in $out; do
repo=$(echo $line | rev | awk -F / '{print $3}' | rev) repo=$(echo $line | rev | awk -F / '{print $3}' | rev)
desc=$(grep "^# description[[:blank:]]*:" $line | sed 's/^# description[[:blank:]]*:[[:blank:]]*//') desc=$(grep "^# description[[:blank:]]*:" $line | sed 's/^# description[[:blank:]]*:[[:blank:]]*//')
name=$(grep "^name=" $line | awk -F = '{print $2}') . $line
version=$(grep "^version=" $line | awk -F = '{print $2}')
release=$(grep "^release=" $line | awk -F = '{print $2}')
echo "($repo) $name $version-$release: $desc" echo "($repo) $name $version-$release: $desc"
unset repo desc name version release unset repo desc name version release build
done done
unset out unset out
done done
@@ -322,6 +334,7 @@ print_runhelp_msg() {
BUILD_SCRIPT="spkgbuild" BUILD_SCRIPT="spkgbuild"
INDEX_DIR="/var/lib/scratchpkg/index" INDEX_DIR="/var/lib/scratchpkg/index"
REPO_FILE="/etc/scratchpkg.repo" REPO_FILE="/etc/scratchpkg.repo"
ALIAS_FILE="/etc/scratchpkg.alias"
if [ -f "$REPO_FILE" ]; then if [ -f "$REPO_FILE" ]; then
for repodir in $(grep -Ev '^(#|$)' "$REPO_FILE" | awk '{print $1}'); do for repodir in $(grep -Ev '^(#|$)' "$REPO_FILE" | awk '{print $1}'); do

83
scratch
View File

@@ -99,13 +99,27 @@ allinstalled() {
grep ^name "$INDEX_DIR"/*/.pkginfo | awk '{print $3}' grep ^name "$INDEX_DIR"/*/.pkginfo | awk '{print $3}'
} }
deps_alias() {
[ -f $ALIAS_FILE ] || {
echo $@
return
}
while [ "$1" ]; do
getalias=$(grep -w ^$1 $ALIAS_FILE | awk '{print $2}')
echo ${getalias:-$1}
shift
done
unset getalias
}
get_depends() { get_depends() {
ppath=$(getportpath $1) || return 0 ppath=$(getportpath $1) || return 0
grep "^# depends[[:blank:]]*:" $ppath/$BUILD_SCRIPT \ deps=$(grep "^# depends[[:blank:]]*:" $ppath/$BUILD_SCRIPT \
| sed 's/^# depends[[:blank:]]*:[[:blank:]]*//' \ | sed 's/^# depends[[:blank:]]*:[[:blank:]]*//' \
| tr ' ' '\n' \ | tr ' ' '\n' \
| awk '!a[$0]++' \ | awk '!a[$0]++' \
| sed 's/,//' | sed 's/,//')
deps_alias $deps
} }
confirm() { confirm() {
@@ -477,16 +491,17 @@ scratch_build() {
return 1 return 1
} }
for pkg in $PKGNAME; do for pkg in $PKGNAME; do
cd $(getportpath $pkg) || { ppath=$(getportpath $pkg) || {
echo "Package '$P' not found." echo "Package '$pkg' not found."
return 1 return 1
} }
settermtitle "Building $P..." cd $ppath
settermtitle "Building $pkg..."
pkgbuild $OPTS || { pkgbuild $OPTS || {
settermtitle "Building $P failed" settermtitle "Building $pkg failed."
return 1 return 1
} }
settermtitle "Building $P done" settermtitle "Building $pkg done."
cd - >/dev/null cd - >/dev/null
done done
} }
@@ -528,9 +543,9 @@ scratch_install() {
cd - >/dev/null cd - >/dev/null
fi fi
done done
settermtitle "Triggering install hook" settermtitle "Triggering install hook..."
[ "$done_pkg" ] && scratch_trigger $done_pkg [ "$done_pkg" ] && scratch_trigger $done_pkg
settermtitle "Reinstalling done" settermtitle "Reinstalling done."
return "$error" return "$error"
fi fi
if [ "$NO_DEP" = 1 ]; then if [ "$NO_DEP" = 1 ]; then
@@ -552,9 +567,9 @@ scratch_install() {
cd - >/dev/null cd - >/dev/null
fi fi
done done
settermtitle "Triggering install hook" settermtitle "Triggering install hook..."
[ "$done_pkg" ] && scratch_trigger $done_pkg [ "$done_pkg" ] && scratch_trigger $done_pkg
settermtitle "Installing done" settermtitle "Installing done."
return "$error" return "$error"
fi fi
for i in $PKGNAME; do for i in $PKGNAME; do
@@ -603,9 +618,9 @@ scratch_install() {
fi fi
unset portpathh unset portpathh
done done
settermtitle "Triggering install hook" settermtitle "Triggering install hook..."
[ "$done_pkg" ] && scratch_trigger $done_pkg [ "$done_pkg" ] && scratch_trigger $done_pkg
settermtitle "$count/$total package(s) installed" settermtitle "$count/$total package(s) installed."
return "$error" return "$error"
fi fi
} }
@@ -656,9 +671,9 @@ scratch_remove() {
break break
} }
done done
settermtitle "Triggering remove hook" settermtitle "Triggering remove hook..."
post_triggers post_triggers
settermtitle "$pkgcount package(s) removed" settermtitle "$pkgcount package(s) removed."
} }
outdatepkg() { outdatepkg() {
@@ -713,7 +728,7 @@ scratch_sysup() {
WILLINSTALL="$WILLINSTALL $d" WILLINSTALL="$WILLINSTALL $d"
UPGPKG=$(( UPGPKG + 1 )) UPGPKG=$(( UPGPKG + 1 ))
elif ! isinstalled $d && [ "$(getportpath "$d")" ]; then elif ! isinstalled $d && [ "$(getportpath "$d")" ]; then
prinf "[${CYAN}n${CRESET}] $d " printf "[${CYAN}n${CRESET}] $d "
WILLINSTALL="$WILLINSTALL $d" WILLINSTALL="$WILLINSTALL $d"
NEWPKG=$(( NEWPKG + 1 )) NEWPKG=$(( NEWPKG + 1 ))
fi fi
@@ -757,9 +772,9 @@ scratch_sysup() {
cd - >/dev/null cd - >/dev/null
done_pkg="$done_pkg $inst" done_pkg="$done_pkg $inst"
done done
settermtitle "Triggering install hook" settermtitle "Triggering install hook."
[ "$done_pkg" ] && scratch_trigger $done_pkg [ "$done_pkg" ] && scratch_trigger $done_pkg
settermtitle "$count/$total package(s) upgraded" settermtitle "$count/$total package(s) upgraded."
return "$error" return "$error"
} }
@@ -853,9 +868,9 @@ scratch_upgrade() {
done_pkg="$done_pkg $pkg" done_pkg="$done_pkg $pkg"
cd - >/dev/null cd - >/dev/null
done done
settermtitle "triggering upgrade hook" settermtitle "triggering upgrade hook..."
[ "$done_pkg" ] && scratch_trigger $done_pkg [ "$done_pkg" ] && scratch_trigger $done_pkg
settermtitle "$count/$total package(s) upgraded" settermtitle "$count/$total package(s) upgraded."
return "$error" return "$error"
} }
@@ -897,6 +912,32 @@ scratch_outdate() {
[ ! "$OUTDATE" ] && msg "All packages are up to date." [ ! "$OUTDATE" ] && msg "All packages are up to date."
} }
scratch_search() {
needarg $@
arg=$*
for repo in $PORT_REPO; do
out=$(grep -R "# description" $repo | grep $BUILD_SCRIPT | grep "$arg" | awk -F : '{print $1}' | sort)
[ "$out" ] || continue
found=1
for line in $out; do
repo=$(echo $line | rev | awk -F / '{print $3}' | rev)
desc=$(grep "^# description[[:blank:]]*:" $line | sed 's/^# description[[:blank:]]*:[[:blank:]]*//')
. $line
if isinstalled $name; then
ins="[${GREEN}*${CRESET}]"
else
ins="[ ]"
fi
printf "$ins ${PURPLE}($repo)${CRESET} $name ${CYAN}$version-$release${CRESET}: $desc\n"
unset repo desc name version release build
done
unset out
done
if [ ! "$found" ]; then
msg "No matching package found."
fi
}
scratch_cache() { scratch_cache() {
needroot "Clear old caches" needroot "Clear old caches"
@@ -1124,6 +1165,7 @@ Options:
unlock <ports> unlock locked ports unlock <ports> unlock locked ports
trigger [ports] run system trigger trigger [ports] run system trigger
sync update ports database sync update ports database
search <pattern> find ports in repo
outdate print outdated ports outdate print outdated ports
cache print and clear old pkg and src caches cache print and clear old pkg and src caches
integrity check installed port integrity integrity check installed port integrity
@@ -1144,6 +1186,7 @@ print_runhelp_msg() {
BUILD_SCRIPT="spkgbuild" BUILD_SCRIPT="spkgbuild"
INDEX_DIR="/var/lib/scratchpkg/index" INDEX_DIR="/var/lib/scratchpkg/index"
REPO_FILE="/etc/scratchpkg.repo" REPO_FILE="/etc/scratchpkg.repo"
ALIAS_FILE="/etc/scratchpkg.alias"
# default value from pkgbuild # default value from pkgbuild
SOURCE_DIR="/var/cache/scratchpkg/sources" SOURCE_DIR="/var/cache/scratchpkg/sources"

9
scratchpkg.alias Normal file
View File

@@ -0,0 +1,9 @@
#
# /etc/scratchpkg.alias : scratchpkg alias file
#
# format:
# <real package> <aliased package>
#
# example:
# openssl libressl
#

View File

@@ -24,8 +24,10 @@ MAKEFLAGS="-j$(nproc)"
# -- buildflags: Enable buildflags (CFLAGS and CXXFLAGS) # -- buildflags: Enable buildflags (CFLAGS and CXXFLAGS)
# -- makeflags: Enable makeflags (MAKEFLAGS) # -- makeflags: Enable makeflags (MAKEFLAGS)
# -- checksum: Enable checking checksum # -- checksum: Enable checking checksum
# -- docs: Keep docs
# -- locales: Keep locales
# #
# -- These are default values for the options="" settings # -- These are default values for the options="" settings
# -- add '!' in front of this option to disable it # -- add '!' in front of this option to disable it
# #
# OPTIONS="!libtool emptydirs strip zipman buildflags makeflags checksum" # OPTIONS="!libtool emptydirs strip zipman buildflags makeflags checksum !docs !locales"

View File

@@ -21,7 +21,7 @@
EDITOR=${EDITOR:-vi} EDITOR=${EDITOR:-vi}
type -p $EDITOR >/dev/null || { type -p $EDITOR >/dev/null || {
echo "Editor '$EDITOR' not exist..." echo "Editor '$EDITOR' not exist. Append 'EDITOR=<your editor>' to ${0##*/}."
exit 2 exit 2
} }

90
xchroot Executable file
View File

@@ -0,0 +1,90 @@
#!/bin/sh
printhelp() {
cat << EOF
Usage:
$(basename $0) <chroot-dir> [command]
If 'command' is unspecified, ${0##*/} will launch /bin/sh.
EOF
}
msgerr() {
echo "ERROR: $*"
}
[ "$(id -u)" = "0" ] || {
msgerr "$(basename $0) need root access!"
printhelp
exit 1
}
TARGET=$1
[ "$1" ] || {
msgerr "Please set directory for chroot!"
printhelp
exit 1
}
[ -d "$TARGET" ] || {
msgerr "Directory '$TARGET' not exist!"
printhelp
exit 1
}
shift
if [ ! "$1" ]; then
CMD="/bin/sh"
else
CMD=$*
fi
if [ -e /sys/firmware/efi/systab ]; then
EFI_SYSTEM=1
fi
mount --bind /dev $TARGET/dev
mount -t devpts devpts $TARGET/dev/pts -o gid=5,mode=620
mount -t proc proc $TARGET/proc
mount -t sysfs sysfs $TARGET/sys
if [ -n "$EFI_SYSTEM" ]; then
mount --bind /sys/firmware/efi/efivars $TARGET/sys/firmware/efi/efivars
fi
mount -t tmpfs tmpfs $TARGET/run
if [ -h $TARGET/dev/shm ]; then
mkdir -p $TARGET/$(readlink $TARGET/dev/shm)
fi
[ -f $TARGET/etc/resolv.conf ] && {
backupresolvconf=1
mv $TARGET/etc/resolv.conf $TARGET/etc/resolv.conf.tmp
}
cp -L /etc/resolv.conf $TARGET/etc
chroot "$TARGET" /usr/bin/env -i \
HOME=/root \
TERM="$TERM" \
PS1='\u:\w\$ ' \
PATH=/bin:/usr/bin:/sbin:/usr/sbin $CMD
retval=$?
[ "$backupresolvconf" = 1 ] && {
mv $TARGET/etc/resolv.conf.tmp $TARGET/etc/resolv.conf
}
umount $TARGET/dev/pts
umount $TARGET/dev
umount $TARGET/run
umount $TARGET/proc
if [ -n "$EFI_SYSTEM" ]; then
umount $TARGET/sys/firmware/efi/efivars
fi
umount $TARGET/sys
exit $retval